import java.awt.*;
import java.util.*;
import java.multimedia.Sprite;
import afapSequencer;

public class SaucerMgr extends Object {
  Component component;
  Vector saucers = new Vector(); // Active, drawable objects
  Vector pool    = new Vector(); // Object pool, active and inactive
  Image  tiledImage;
  Sprite currentSprite;
  
  public SaucerMgr(Component comp, Image imageSrc) {
    component = comp;
    tiledImage = imageSrc;
    add(true); add(true); add(true); add(true); add(true); add(true); add(true); add(true);
    add(true); add(true); add(true); add(true); add(true); add(true); add(true); add(true);
    add(true); add(true); add(true); add(true); add(true); add(true); add(true); add(true);
    add(true); add(true); add(true); add(true); add(true); add(true); add(true); add(true);
    add(true); add(true); add(true); add(true); add(true); add(true); add(true); add(true);
  }
  
  public void updateAll() {
    long time = (new Date()).getTime();
    for (int i = 0; i < saucers.size(); ++i) {
      currentSprite = (Sprite)saucers.elementAt(i);
      currentSprite.update(time);
      if (currentSprite.expired) {
        saucers.removeElementAt(i);
        add(false);
      }
    }
  }
    
  public void drawAll(Graphics g) {
      for (int i = 0; i < saucers.size(); ++i)
      ((Sprite)saucers.elementAt(i)).draw(false,g);
  }
  
  public int size() {
    return saucers.size();
  }
  
  public int add(boolean forceNew) {
    int j = -1; 
    Sprite s;
    
    // If not forced, find a free one from the object pool.
    if (! forceNew) {
      for (int i=0; i < pool.size(); ++i) {
        if (((Sprite)pool.elementAt(i)).expired) {
          j = i;
          break;
        }
      }
    }
    
    // Couldn't find a free one in the pool, allocate new object
    if ((j < 0) || forceNew) {
      s = new Sprite(new afapSequencer(11), 37, 23);
      s.reset(component, tiledImage,
              (int)(Math.random()*200.0),
              (int)(Math.random()*200.0),
              (Math.random()-0.4)/3.0,
              (Math.random()-0.4)/3.0);
      pool.addElement(s);
      saucers.addElement(s);
    } else {
      s = (Sprite)pool.elementAt(j);
      s.reset(component, tiledImage,
              (int)(Math.random()*200.0),
              (int)(Math.random()*200.0),
              (Math.random()-0.4)/3.0, (Math.random()-0.4)/3.0);
      saucers.addElement(s);
    }
    return (saucers.size()-1);
  }
  
  public void remove() {
    int tmp = saucers.size();
    if (tmp > 1) {
      ((Sprite)saucers.elementAt(saucers.size()-1)).expired=true;
	    saucers.removeElementAt(saucers.size()-1);
    }
  }
}