// storchDlg.cpp : implementation file
//

#include "stdafx.h"
#include "storch.h"
#include "storchDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

// CStorchDlg dialog

CStorchDlg::CStorchDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CStorchDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CStorchDlg)
	//}}AFX_DATA_INIT
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
	devid = rdevid = 0;
	timer = 0;
}
void CStorchDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CStorchDlg)
	DDX_Control(pDX, IDC_PLAYBACK, m_Playback);
	DDX_Control(pDX, IDC_RECORD, m_Record);
	DDX_Control(pDX, IDC_PLAYFILE, m_Play);
	DDX_Control(pDX, IDC_PHRASES, m_Phrases);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CStorchDlg, CDialog)
	//{{AFX_MSG_MAP(CStorchDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_WM_DESTROY()
	ON_BN_CLICKED(IDC_ADDFILE, OnAddfile)
	ON_BN_CLICKED(IDC_PLAYFILE, OnPlayfile)
	ON_BN_CLICKED(IDC_DELETEFILE, OnDeletefile)
	ON_WM_TIMER()
	ON_BN_CLICKED(IDC_RECORD, OnRecord)
	ON_BN_CLICKED(IDC_PLAYBACK, OnPlayback)
	ON_BN_CLICKED(IDC_COMPARE, OnCompare)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CStorchDlg message handlers

BOOL CStorchDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// --- load the previous file list from the registry
	int size = theApp.GetProfileInt("Settings", "Files", 0);
	for (int ct = 0; ct < size; ct++)	{
		CString fc;
		fc.Format("File%03d", ct + 1);
		CString file = theApp.GetProfileString("Settings", fc);
		if (!file.IsEmpty())
			m_Phrases.AddString(file);
	}
	// ----- select the file that was last selected
	short int cursel = theApp.GetProfileInt("Settings", "File", -1);
	if (size > 0 && (cursel == -1 || cursel >= size))
		cursel = 0;
	m_Phrases.SetCurSel(cursel);
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CStorchDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)	{
		CDialog dlgAbout(IDD_ABOUTBOX);
		dlgAbout.DoModal();
	}
	else
		CDialog::OnSysCommand(nID, lParam);
}

HCURSOR CStorchDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CStorchDlg::OnDestroy() 
{
	CloseRecordDevice();
	int size = m_Phrases.GetCount();
	// --- save the file list in the registry
	theApp.WriteProfileInt("Settings", "Files", size);
	for (int i = 0; i < size; i++)	{
		CString file;
		m_Phrases.GetText(i, file);
		CString fc;
		fc.Format("File%03d", i + 1);
		theApp.WriteProfileString("Settings", fc, file);
	}
	theApp.WriteProfileInt("Settings", "File", m_Phrases.GetCurSel());
	WinHelp(0L, HELP_QUIT);
	CDialog::OnDestroy();
}


void CStorchDlg::OnAddfile() 
{
	// ---- go to the path last used to select files to display
	CString path = theApp.GetProfileString("Settings", "Path");
	if (!path.IsEmpty())
		_chdir(path.GetBuffer(0));
	// --- common open file dialog
	CFileDialog dlg(TRUE,
					"wav",
					0,
					OFN_ALLOWMULTISELECT | 
					OFN_HIDEREADONLY | 
					OFN_FILEMUSTEXIST | 
					OFN_PATHMUSTEXIST,
					"Sound Files (*.wav)|*.wav||"
					);

	if (dlg.DoModal() == IDOK)	{
		// --- save the count to set current selection to beginning of what is added
		int sel = m_Phrases.GetCount();
		// --- add the selected file(s) to the play list
		POSITION pos = dlg.GetStartPosition();
		int ct = 0;
		do	{
			path = dlg.GetNextPathName(pos);
			m_Phrases.AddString(path);
			ct++;
		} while (pos != 0);
		// --- post the path to the registry for next time
		theApp.WriteProfileString("Settings", "Path", path);
		// --- set the selection to the first of the files added
		m_Phrases.SetCurSel(sel);
	}
}

void CStorchDlg::OnDeletefile() 
{
	int sel = m_Phrases.GetCurSel();
	if (sel != LB_ERR)	{
		m_Phrases.DeleteString(sel);
		int ct = m_Phrases.GetCount();
		if (ct > 0)	{
			if (sel == ct)
				--sel;
			m_Phrases.SetCurSel(sel);
		}
	}	
}

void CStorchDlg::OnPlayfile() 
{
	if (devid == 0)	{
		int sel = m_Phrases.GetCurSel();
		m_Phrases.GetText(sel, file);
		PlayFile();	
	}
	else
		CloseFile();
}

void CStorchDlg::PlayFile()
{
	MCI_OPEN_PARMS op = { 0 };
	op.lpstrDeviceType = "waveaudio";
	op.lpstrElementName = file.GetBuffer(0);
	if (mciSendCommand(0, MCI_OPEN, MCI_OPEN_TYPE | MCI_OPEN_ELEMENT, (DWORD)(LPVOID) &op) == 0)	{
		devid = op.wDeviceID;
		MCI_PLAY_PARMS pp = { 0 };
		pp.dwCallback = (DWORD) m_hWnd;
		m_Play.SetWindowText("&Stop");
		timer = 0;
		SetTimer(1, 100, 0);
		if (mciSendCommand(devid, MCI_PLAY, MCI_NOTIFY, (DWORD)(LPVOID) &pp))
			CloseFile();
	}
}

void CStorchDlg::CloseFile()
{
	if (devid)	{
		m_Play.SetWindowText("&Play File");
		mciSendCommand(devid, MCI_CLOSE, 0, 0);
		devid = 0;
		KillTimer(1);
	}
}

LRESULT CStorchDlg::DefWindowProc(UINT message, WPARAM wParam, LPARAM lParam) 
{
	if (message == MM_MCINOTIFY)
		CloseFile();
	return CDialog::DefWindowProc(message, wParam, lParam);
}


void CStorchDlg::OnTimer(UINT nIDEvent) 
{
	if (nIDEvent == 1)	{
		KillTimer(1);
		SetTimer(1, 100, 0);
		timer += 100;
	}
	CDialog::OnTimer(nIDEvent);
}


void CStorchDlg::CloseRecordDevice()
{
	if (rdevid)	{
		mciSendCommand(rdevid, MCI_CLOSE, 0, 0);
		rdevid = 0;
	}
}
void CStorchDlg::OnRecord() 
{
	CloseRecordDevice();
	MCI_OPEN_PARMS op = { 0 };
	op.lpstrDeviceType = "waveaudio";
	op.lpstrElementName = "";
	if (mciSendCommand(0, MCI_OPEN, MCI_OPEN_TYPE | MCI_OPEN_ELEMENT, (DWORD)(LPVOID) &op) == 0)	{
		rdevid = op.wDeviceID;
		MCI_RECORD_PARMS rp = { 0 };
		rp.dwTo = timer + 1000;	// extra second
		if (mciSendCommand(rdevid, MCI_RECORD, MCI_TO | MCI_WAIT, (DWORD)(LPVOID) &rp))
			CloseRecordDevice();
	}
}

void CStorchDlg::OnPlayback() 
{
	if (rdevid)	{
		MCI_PLAY_PARMS pp = { 0 };
		if (mciSendCommand(rdevid, MCI_PLAY, MCI_FROM | MCI_WAIT, (DWORD)(LPVOID) &pp))
			CloseRecordDevice();
	}
}

void CStorchDlg::OnCompare() 
{
	if (rdevid)	{
		MCI_OPEN_PARMS op = { 0 };
		op.lpstrDeviceType = "waveaudio";
		op.lpstrElementName = file.GetBuffer(0);
		if (mciSendCommand(0, MCI_OPEN, MCI_OPEN_TYPE | MCI_OPEN_ELEMENT, (DWORD)(LPVOID) &op) == 0)	{
			UINT pdevid = op.wDeviceID;
			MCI_PLAY_PARMS pp = { 0 };
			mciSendCommand(pdevid, MCI_PLAY, MCI_WAIT, (DWORD)(LPVOID) &pp);
			mciSendCommand(pdevid, MCI_CLOSE, 0, 0);
			mciSendCommand(rdevid, MCI_PLAY, MCI_FROM | MCI_WAIT, (DWORD)(LPVOID) &pp);
		}
	}	
}
